/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM mozISqlConnection.idl
 */

#ifndef __gen_mozISqlConnection_h__
#define __gen_mozISqlConnection_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class mozISqlResult; /* forward declaration */

class mozISqlRequest; /* forward declaration */

class mozISqlRequestObserver; /* forward declaration */


/* starting interface:    mozISqlConnection */
#define MOZISQLCONNECTION_IID_STR "f16397a4-1ecb-4e08-84f8-27750c04b779"

#define MOZISQLCONNECTION_IID \
  {0xf16397a4, 0x1ecb, 0x4e08, \
    { 0x84, 0xf8, 0x27, 0x75, 0x0c, 0x04, 0xb7, 0x79 }}

/**
 * A connection to a SQL database. This interface may be further extended
 * by a particular database implementation. The SQL service is responsible
 * for creating and maintaining connections, so there isn't a means to create
 * one directly via this interface.
 *
 * @status UNDER_REVIEW
 */
class NS_NO_VTABLE mozISqlConnection : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(MOZISQLCONNECTION_IID)

  /**
   * A string holding the name and/or version info of the database.
   */
  /* readonly attribute AString serverVersion; */
  NS_IMETHOD GetServerVersion(nsAString & aServerVersion) = 0;

  /**
   * The most recent error message.
   */
  /* readonly attribute AString errorMessage; */
  NS_IMETHOD GetErrorMessage(nsAString & aErrorMessage) = 0;

  /**
   * The ID of the most recently added record.
   */
  /* readonly attribute long lastID; */
  NS_IMETHOD GetLastID(PRInt32 *aLastID) = 0;

  /**
   * Set up the connection. This is called by the SQL service. There is no
   * need to call this method directly.
   *
   * @param aHost       the host name.
   * @param aPort       the port at which the host is listening.
   * @param aDatabase   the real database name to connect to.
   * @param aUsername   the username to connect as.
   * @param aPassword   the password to use in authentification phase.   
   */
  /* void init (in AString aHost, in long aPort, in AString aDatabase, in AString aUsername, in AString aPassword); */
  NS_IMETHOD Init(const nsAString & aHost, PRInt32 aPort, const nsAString & aDatabase, const nsAString & aUsername, const nsAString & aPassword) = 0;

  /**
   * Execute an SQL query synchronously and return the query result.
   *
   * @param aQuery      the SQL string of the query to execute
   * @return            the result of the query
   */
  /* mozISqlResult executeQuery (in AString aQuery); */
  NS_IMETHOD ExecuteQuery(const nsAString & aQuery, mozISqlResult **_retval) = 0;

  /**
   * Execute an SQL update synchronously and return the number of updated
   * rows.
   *
   * @param aUpdate     the update to execute
   * @return            the result of the query
   */
  /* long executeUpdate (in AString aUpdate); */
  NS_IMETHOD ExecuteUpdate(const nsAString & aUpdate, PRInt32 *_retval) = 0;

  /**
   * Execute an SQL query asynchronously and return a request. An observer
   * may be used to track when the query has completed.
   *
   * @param aQuery      the SQL string of the query to execute
   * @param aContext    extra argument that will be passed to the observer
   * @param aObserver   observer that will be notified when the query is done
   * @return            a request object
   */
  /* mozISqlRequest asyncExecuteQuery (in AString aQuery, in nsISupports aContext, in mozISqlRequestObserver aObserver); */
  NS_IMETHOD AsyncExecuteQuery(const nsAString & aQuery, nsISupports *aContext, mozISqlRequestObserver *aObserver, mozISqlRequest **_retval) = 0;

  /**
   * Execute an SQL update asynchronously and return a request. An observer
   * may be used to track when the query has completed.
   *
   * @param aQuery      the SQL string of the update to execute
   * @param aContext    extra argument that will be passed to the observer
   * @param aObserver   observer that will be notified when the update is done
   * @return            a request object
   */
  /* mozISqlRequest asyncExecuteUpdate (in AString aQuery, in nsISupports aContext, in mozISqlRequestObserver aObserver); */
  NS_IMETHOD AsyncExecuteUpdate(const nsAString & aQuery, nsISupports *aContext, mozISqlRequestObserver *aObserver, mozISqlRequest **_retval) = 0;

  /**
   * Begin a transaction. Updates made during the transaction will not be
   * made permanent until it is committed using commitTransaction.
   */
  /* void beginTransaction (); */
  NS_IMETHOD BeginTransaction(void) = 0;

  /**
   * Commit the current transaction
   */
  /* void commitTransaction (); */
  NS_IMETHOD CommitTransaction(void) = 0;

  /**
   * Rollback (cancel) the current transaction
   */
  /* void rollbackTransaction (); */
  NS_IMETHOD RollbackTransaction(void) = 0;

  /**
   * Return the primary keys of a given table.
   *
   * @param aSchema     the schema
   * @param aTable      the table name of the keys to retrieve
   * @return            the result which holds the keys
   */
  /* mozISqlResult getPrimaryKeys (in AString aSchema, in AString aTable); */
  NS_IMETHOD GetPrimaryKeys(const nsAString & aSchema, const nsAString & aTable, mozISqlResult **_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_MOZISQLCONNECTION \
  NS_IMETHOD GetServerVersion(nsAString & aServerVersion); \
  NS_IMETHOD GetErrorMessage(nsAString & aErrorMessage); \
  NS_IMETHOD GetLastID(PRInt32 *aLastID); \
  NS_IMETHOD Init(const nsAString & aHost, PRInt32 aPort, const nsAString & aDatabase, const nsAString & aUsername, const nsAString & aPassword); \
  NS_IMETHOD ExecuteQuery(const nsAString & aQuery, mozISqlResult **_retval); \
  NS_IMETHOD ExecuteUpdate(const nsAString & aUpdate, PRInt32 *_retval); \
  NS_IMETHOD AsyncExecuteQuery(const nsAString & aQuery, nsISupports *aContext, mozISqlRequestObserver *aObserver, mozISqlRequest **_retval); \
  NS_IMETHOD AsyncExecuteUpdate(const nsAString & aQuery, nsISupports *aContext, mozISqlRequestObserver *aObserver, mozISqlRequest **_retval); \
  NS_IMETHOD BeginTransaction(void); \
  NS_IMETHOD CommitTransaction(void); \
  NS_IMETHOD RollbackTransaction(void); \
  NS_IMETHOD GetPrimaryKeys(const nsAString & aSchema, const nsAString & aTable, mozISqlResult **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_MOZISQLCONNECTION(_to) \
  NS_IMETHOD GetServerVersion(nsAString & aServerVersion) { return _to GetServerVersion(aServerVersion); } \
  NS_IMETHOD GetErrorMessage(nsAString & aErrorMessage) { return _to GetErrorMessage(aErrorMessage); } \
  NS_IMETHOD GetLastID(PRInt32 *aLastID) { return _to GetLastID(aLastID); } \
  NS_IMETHOD Init(const nsAString & aHost, PRInt32 aPort, const nsAString & aDatabase, const nsAString & aUsername, const nsAString & aPassword) { return _to Init(aHost, aPort, aDatabase, aUsername, aPassword); } \
  NS_IMETHOD ExecuteQuery(const nsAString & aQuery, mozISqlResult **_retval) { return _to ExecuteQuery(aQuery, _retval); } \
  NS_IMETHOD ExecuteUpdate(const nsAString & aUpdate, PRInt32 *_retval) { return _to ExecuteUpdate(aUpdate, _retval); } \
  NS_IMETHOD AsyncExecuteQuery(const nsAString & aQuery, nsISupports *aContext, mozISqlRequestObserver *aObserver, mozISqlRequest **_retval) { return _to AsyncExecuteQuery(aQuery, aContext, aObserver, _retval); } \
  NS_IMETHOD AsyncExecuteUpdate(const nsAString & aQuery, nsISupports *aContext, mozISqlRequestObserver *aObserver, mozISqlRequest **_retval) { return _to AsyncExecuteUpdate(aQuery, aContext, aObserver, _retval); } \
  NS_IMETHOD BeginTransaction(void) { return _to BeginTransaction(); } \
  NS_IMETHOD CommitTransaction(void) { return _to CommitTransaction(); } \
  NS_IMETHOD RollbackTransaction(void) { return _to RollbackTransaction(); } \
  NS_IMETHOD GetPrimaryKeys(const nsAString & aSchema, const nsAString & aTable, mozISqlResult **_retval) { return _to GetPrimaryKeys(aSchema, aTable, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_MOZISQLCONNECTION(_to) \
  NS_IMETHOD GetServerVersion(nsAString & aServerVersion) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetServerVersion(aServerVersion); } \
  NS_IMETHOD GetErrorMessage(nsAString & aErrorMessage) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetErrorMessage(aErrorMessage); } \
  NS_IMETHOD GetLastID(PRInt32 *aLastID) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLastID(aLastID); } \
  NS_IMETHOD Init(const nsAString & aHost, PRInt32 aPort, const nsAString & aDatabase, const nsAString & aUsername, const nsAString & aPassword) { return !_to ? NS_ERROR_NULL_POINTER : _to->Init(aHost, aPort, aDatabase, aUsername, aPassword); } \
  NS_IMETHOD ExecuteQuery(const nsAString & aQuery, mozISqlResult **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->ExecuteQuery(aQuery, _retval); } \
  NS_IMETHOD ExecuteUpdate(const nsAString & aUpdate, PRInt32 *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->ExecuteUpdate(aUpdate, _retval); } \
  NS_IMETHOD AsyncExecuteQuery(const nsAString & aQuery, nsISupports *aContext, mozISqlRequestObserver *aObserver, mozISqlRequest **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->AsyncExecuteQuery(aQuery, aContext, aObserver, _retval); } \
  NS_IMETHOD AsyncExecuteUpdate(const nsAString & aQuery, nsISupports *aContext, mozISqlRequestObserver *aObserver, mozISqlRequest **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->AsyncExecuteUpdate(aQuery, aContext, aObserver, _retval); } \
  NS_IMETHOD BeginTransaction(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->BeginTransaction(); } \
  NS_IMETHOD CommitTransaction(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->CommitTransaction(); } \
  NS_IMETHOD RollbackTransaction(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->RollbackTransaction(); } \
  NS_IMETHOD GetPrimaryKeys(const nsAString & aSchema, const nsAString & aTable, mozISqlResult **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPrimaryKeys(aSchema, aTable, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public mozISqlConnection
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_MOZISQLCONNECTION

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, mozISqlConnection)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* readonly attribute AString serverVersion; */
NS_IMETHODIMP _MYCLASS_::GetServerVersion(nsAString & aServerVersion)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString errorMessage; */
NS_IMETHODIMP _MYCLASS_::GetErrorMessage(nsAString & aErrorMessage)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long lastID; */
NS_IMETHODIMP _MYCLASS_::GetLastID(PRInt32 *aLastID)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void init (in AString aHost, in long aPort, in AString aDatabase, in AString aUsername, in AString aPassword); */
NS_IMETHODIMP _MYCLASS_::Init(const nsAString & aHost, PRInt32 aPort, const nsAString & aDatabase, const nsAString & aUsername, const nsAString & aPassword)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* mozISqlResult executeQuery (in AString aQuery); */
NS_IMETHODIMP _MYCLASS_::ExecuteQuery(const nsAString & aQuery, mozISqlResult **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* long executeUpdate (in AString aUpdate); */
NS_IMETHODIMP _MYCLASS_::ExecuteUpdate(const nsAString & aUpdate, PRInt32 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* mozISqlRequest asyncExecuteQuery (in AString aQuery, in nsISupports aContext, in mozISqlRequestObserver aObserver); */
NS_IMETHODIMP _MYCLASS_::AsyncExecuteQuery(const nsAString & aQuery, nsISupports *aContext, mozISqlRequestObserver *aObserver, mozISqlRequest **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* mozISqlRequest asyncExecuteUpdate (in AString aQuery, in nsISupports aContext, in mozISqlRequestObserver aObserver); */
NS_IMETHODIMP _MYCLASS_::AsyncExecuteUpdate(const nsAString & aQuery, nsISupports *aContext, mozISqlRequestObserver *aObserver, mozISqlRequest **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void beginTransaction (); */
NS_IMETHODIMP _MYCLASS_::BeginTransaction()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void commitTransaction (); */
NS_IMETHODIMP _MYCLASS_::CommitTransaction()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void rollbackTransaction (); */
NS_IMETHODIMP _MYCLASS_::RollbackTransaction()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* mozISqlResult getPrimaryKeys (in AString aSchema, in AString aTable); */
NS_IMETHODIMP _MYCLASS_::GetPrimaryKeys(const nsAString & aSchema, const nsAString & aTable, mozISqlResult **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_mozISqlConnection_h__ */
