/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIXFormsContextControl.idl
 */

#ifndef __gen_nsIXFormsContextControl_h__
#define __gen_nsIXFormsContextControl_h__


#ifndef __gen_nsIXFormsControlBase_h__
#include "nsIXFormsControlBase.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIDOMNode; /* forward declaration */

class nsIDOMElement; /* forward declaration */

class nsIXFormsControl; /* forward declaration */


/* starting interface:    nsIXFormsContextControl */
#define NS_IXFORMSCONTEXTCONTROL_IID_STR "35660a75-86f0-4eaf-9da9-f47e2f5466da"

#define NS_IXFORMSCONTEXTCONTROL_IID \
  {0x35660a75, 0x86f0, 0x4eaf, \
    { 0x9d, 0xa9, 0xf4, 0x7e, 0x2f, 0x54, 0x66, 0xda }}

/**
 * Interface for elements that sets the XPath context of its children.
 */
class NS_NO_VTABLE nsIXFormsContextControl : public nsIXFormsControlBase {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IXFORMSCONTEXTCONTROL_IID)

  /**
   * Used by children to retrieve the context of their parent.
   *
   * @param aModelID          The modelID
   * @param aContextNode      The context node
   * @param aContextPosition  The context position
   * @param aContextSize      The context size
   * 
   * @note The actual model ID must be returned. An empty |aModelID| should
   * only be returned if the default model has an id="".
   */
  /* void getContext (out AString aModelID, out nsIDOMNode aContextNode, out long aContextPosition, out long aContextSize); */
  NS_IMETHOD GetContext(nsAString & aModelID, nsIDOMNode **aContextNode, PRInt32 *aContextPosition, PRInt32 *aContextSize) = 0;

  /**
   * Used by parents to set the context for children.
   *
   * @param aContextNode      The context node
   * @param aContextPosition  The context position
   * @param aContextSize      The context size
   */
  /* void setContext (in nsIDOMNode aContextNode, in long aContextPosition, in long aContextSize); */
  NS_IMETHOD SetContext(nsIDOMNode *aContextNode, PRInt32 aContextPosition, PRInt32 aContextSize) = 0;

  /**
   * Each context control maintains an 'aborted bind' list.  This list is
   * used to track xforms controls that this context control contains
   * which have tried to bind but couldn't because this context control
   * wasn't bound yet, either.
   *
   * @param aControl          The XForms control that couldn't bind because
   *                          this context control wasn't ready.
   * @param addControl        If true, aControl is added to the list.  If false
   *                          aControl will be removed from the list and also
   *                          aControl will lose its link to this control.
   */
  /* void addRemoveAbortedControl (in nsIXFormsControl aControl, in boolean aAddControl); */
  NS_IMETHOD AddRemoveAbortedControl(nsIXFormsControl *aControl, PRBool aAddControl) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIXFORMSCONTEXTCONTROL \
  NS_IMETHOD GetContext(nsAString & aModelID, nsIDOMNode **aContextNode, PRInt32 *aContextPosition, PRInt32 *aContextSize); \
  NS_IMETHOD SetContext(nsIDOMNode *aContextNode, PRInt32 aContextPosition, PRInt32 aContextSize); \
  NS_IMETHOD AddRemoveAbortedControl(nsIXFormsControl *aControl, PRBool aAddControl); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIXFORMSCONTEXTCONTROL(_to) \
  NS_IMETHOD GetContext(nsAString & aModelID, nsIDOMNode **aContextNode, PRInt32 *aContextPosition, PRInt32 *aContextSize) { return _to GetContext(aModelID, aContextNode, aContextPosition, aContextSize); } \
  NS_IMETHOD SetContext(nsIDOMNode *aContextNode, PRInt32 aContextPosition, PRInt32 aContextSize) { return _to SetContext(aContextNode, aContextPosition, aContextSize); } \
  NS_IMETHOD AddRemoveAbortedControl(nsIXFormsControl *aControl, PRBool aAddControl) { return _to AddRemoveAbortedControl(aControl, aAddControl); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIXFORMSCONTEXTCONTROL(_to) \
  NS_IMETHOD GetContext(nsAString & aModelID, nsIDOMNode **aContextNode, PRInt32 *aContextPosition, PRInt32 *aContextSize) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetContext(aModelID, aContextNode, aContextPosition, aContextSize); } \
  NS_IMETHOD SetContext(nsIDOMNode *aContextNode, PRInt32 aContextPosition, PRInt32 aContextSize) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetContext(aContextNode, aContextPosition, aContextSize); } \
  NS_IMETHOD AddRemoveAbortedControl(nsIXFormsControl *aControl, PRBool aAddControl) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddRemoveAbortedControl(aControl, aAddControl); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsXFormsContextControl : public nsIXFormsContextControl
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIXFORMSCONTEXTCONTROL

  nsXFormsContextControl();

private:
  ~nsXFormsContextControl();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsXFormsContextControl, nsIXFormsContextControl)

nsXFormsContextControl::nsXFormsContextControl()
{
  /* member initializers and constructor code */
}

nsXFormsContextControl::~nsXFormsContextControl()
{
  /* destructor code */
}

/* void getContext (out AString aModelID, out nsIDOMNode aContextNode, out long aContextPosition, out long aContextSize); */
NS_IMETHODIMP nsXFormsContextControl::GetContext(nsAString & aModelID, nsIDOMNode **aContextNode, PRInt32 *aContextPosition, PRInt32 *aContextSize)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setContext (in nsIDOMNode aContextNode, in long aContextPosition, in long aContextSize); */
NS_IMETHODIMP nsXFormsContextControl::SetContext(nsIDOMNode *aContextNode, PRInt32 aContextPosition, PRInt32 aContextSize)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void addRemoveAbortedControl (in nsIXFormsControl aControl, in boolean aAddControl); */
NS_IMETHODIMP nsXFormsContextControl::AddRemoveAbortedControl(nsIXFormsControl *aControl, PRBool aAddControl)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIXFormsContextControl_h__ */
