/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIXFormsContextInfo.idl
 */

#ifndef __gen_nsIXFormsContextInfo_h__
#define __gen_nsIXFormsContextInfo_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIDOMNode_h__
#include "nsIDOMNode.h"
#endif

#ifndef __gen_nsIDOMXPathResult_h__
#include "nsIDOMXPathResult.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    nsIXFormsContextInfo */
#define NS_IXFORMSCONTEXTINFO_IID_STR "b012a3e5-7dbc-42b4-99da-5e94c37dc44e"

#define NS_IXFORMSCONTEXTINFO_IID \
  {0xb012a3e5, 0x7dbc, 0x42b4, \
    { 0x99, 0xda, 0x5e, 0x94, 0xc3, 0x7d, 0xc4, 0x4e }}

/**
 * Interface exposing the event context info of an XForms control.
 *
 * Context info is accessed by name using nsIXFormsDOMEvent::GetContextInfo
 * or the XPath function event().
 *
 */
class NS_NO_VTABLE nsIXFormsContextInfo : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IXFORMSCONTEXTINFO_IID)

  /* readonly attribute DOMString name; */
  NS_IMETHOD GetName(nsAString & aName) = 0;

  enum { STRING_TYPE = 1U };

  enum { NUMBER_TYPE = 2U };

  enum { NODE_TYPE = 3U };

  enum { NODESET_TYPE = 4U };

  /* readonly attribute long type; */
  NS_IMETHOD GetType(PRInt32 *aType) = 0;

  /** Get the value of a STRING_TYPE context info property.
   */
  /* readonly attribute DOMString stringValue; */
  NS_IMETHOD GetStringValue(nsAString & aStringValue) = 0;

  /** Get the value of a NUMBER_TYPE context info property.
   */
  /* readonly attribute long numberValue; */
  NS_IMETHOD GetNumberValue(PRInt32 *aNumberValue) = 0;

  /** Get the value of a NODE_TYPE context info property.
   */
  /* readonly attribute nsIDOMNode nodeValue; */
  NS_IMETHOD GetNodeValue(nsIDOMNode * *aNodeValue) = 0;

  /** Get the value of a NODESET_TYPE context info property.
   */
  /* readonly attribute nsIDOMXPathResult nodesetValue; */
  NS_IMETHOD GetNodesetValue(nsIDOMXPathResult * *aNodesetValue) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIXFORMSCONTEXTINFO \
  NS_IMETHOD GetName(nsAString & aName); \
  NS_IMETHOD GetType(PRInt32 *aType); \
  NS_IMETHOD GetStringValue(nsAString & aStringValue); \
  NS_IMETHOD GetNumberValue(PRInt32 *aNumberValue); \
  NS_IMETHOD GetNodeValue(nsIDOMNode * *aNodeValue); \
  NS_IMETHOD GetNodesetValue(nsIDOMXPathResult * *aNodesetValue); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIXFORMSCONTEXTINFO(_to) \
  NS_IMETHOD GetName(nsAString & aName) { return _to GetName(aName); } \
  NS_IMETHOD GetType(PRInt32 *aType) { return _to GetType(aType); } \
  NS_IMETHOD GetStringValue(nsAString & aStringValue) { return _to GetStringValue(aStringValue); } \
  NS_IMETHOD GetNumberValue(PRInt32 *aNumberValue) { return _to GetNumberValue(aNumberValue); } \
  NS_IMETHOD GetNodeValue(nsIDOMNode * *aNodeValue) { return _to GetNodeValue(aNodeValue); } \
  NS_IMETHOD GetNodesetValue(nsIDOMXPathResult * *aNodesetValue) { return _to GetNodesetValue(aNodesetValue); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIXFORMSCONTEXTINFO(_to) \
  NS_IMETHOD GetName(nsAString & aName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetName(aName); } \
  NS_IMETHOD GetType(PRInt32 *aType) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetType(aType); } \
  NS_IMETHOD GetStringValue(nsAString & aStringValue) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStringValue(aStringValue); } \
  NS_IMETHOD GetNumberValue(PRInt32 *aNumberValue) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetNumberValue(aNumberValue); } \
  NS_IMETHOD GetNodeValue(nsIDOMNode * *aNodeValue) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetNodeValue(aNodeValue); } \
  NS_IMETHOD GetNodesetValue(nsIDOMXPathResult * *aNodesetValue) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetNodesetValue(aNodesetValue); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsXFormsContextInfo : public nsIXFormsContextInfo
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIXFORMSCONTEXTINFO

  nsXFormsContextInfo();

private:
  ~nsXFormsContextInfo();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsXFormsContextInfo, nsIXFormsContextInfo)

nsXFormsContextInfo::nsXFormsContextInfo()
{
  /* member initializers and constructor code */
}

nsXFormsContextInfo::~nsXFormsContextInfo()
{
  /* destructor code */
}

/* readonly attribute DOMString name; */
NS_IMETHODIMP nsXFormsContextInfo::GetName(nsAString & aName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long type; */
NS_IMETHODIMP nsXFormsContextInfo::GetType(PRInt32 *aType)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute DOMString stringValue; */
NS_IMETHODIMP nsXFormsContextInfo::GetStringValue(nsAString & aStringValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long numberValue; */
NS_IMETHODIMP nsXFormsContextInfo::GetNumberValue(PRInt32 *aNumberValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIDOMNode nodeValue; */
NS_IMETHODIMP nsXFormsContextInfo::GetNodeValue(nsIDOMNode * *aNodeValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIDOMXPathResult nodesetValue; */
NS_IMETHODIMP nsXFormsContextInfo::GetNodesetValue(nsIDOMXPathResult * *aNodesetValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIXFormsContextInfo_h__ */
