/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIXFormsItemElement.idl
 */

#ifndef __gen_nsIXFormsItemElement_h__
#define __gen_nsIXFormsItemElement_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIDOMNode_h__
#include "nsIDOMNode.h"
#endif

#ifndef __gen_nsIXFormsDelegate_h__
#include "nsIXFormsDelegate.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    nsIXFormsItemElement */
#define NS_IXFORMSITEMELEMENT_IID_STR "e7e65a10-bf37-488f-9c74-add34abdd309"

#define NS_IXFORMSITEMELEMENT_IID \
  {0xe7e65a10, 0xbf37, 0x488f, \
    { 0x9c, 0x74, 0xad, 0xd3, 0x4a, 0xbd, 0xd3, 0x09 }}

/**
 * Interface implemented by the item element.
 */
class NS_NO_VTABLE nsIXFormsItemElement : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IXFORMSITEMELEMENT_IID)

  /**
   * The text value of the \<label\> child element of the item.
   */
  /* readonly attribute AString labelText; */
  NS_IMETHOD GetLabelText(nsAString & aLabelText) = 0;

  /**
   * The value of the item element.
   */
  /* readonly attribute AString value; */
  NS_IMETHOD GetValue(nsAString & aValue) = 0;

  /**
   * Marks item active. In current implementation '_moz_active' attribute is 
   * set to the element if aActive is true. The attribute can be used when
   * styling the element.
   */
  /* void setActive (in boolean aActive); */
  NS_IMETHOD SetActive(PRBool aActive) = 0;

  /**
   * This is called by the \<label\> child element whenever it is refreshed.
   * This information will be propagated by the \<item\> to the nearest
   * \<select1\> element, which can then refresh its UI.
   */
  /* void labelRefreshed (); */
  NS_IMETHOD LabelRefreshed(void) = 0;

  /**
   * Indicates whether the item element contains a value child or a copy
   * child.  We'll assume that if the item is NOT a copy item, then it must
   * be a value item.  Which means that it must contain a XForms value element
   * child.
   */
  /* attribute boolean isCopyItem; */
  NS_IMETHOD GetIsCopyItem(PRBool *aIsCopyItem) = 0;
  NS_IMETHOD SetIsCopyItem(PRBool aIsCopyItem) = 0;

  /* readonly attribute nsIDOMNode copyNode; */
  NS_IMETHOD GetCopyNode(nsIDOMNode * *aCopyNode) = 0;

  /**
   * Compare given DOM node and copy node (i.e. node that the contained copy
   * element is bound to.
   *
   * @param nsIDOMNode aNode - given DOM node to compare with copy node
   *
   * @return boolean - return true if given node equals in copy node
   */
  /* boolean copyNodeEquals (in nsIDOMNode aNode); */
  NS_IMETHOD CopyNodeEquals(nsIDOMNode *aNode, PRBool *_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIXFORMSITEMELEMENT \
  NS_IMETHOD GetLabelText(nsAString & aLabelText); \
  NS_IMETHOD GetValue(nsAString & aValue); \
  NS_IMETHOD SetActive(PRBool aActive); \
  NS_IMETHOD LabelRefreshed(void); \
  NS_IMETHOD GetIsCopyItem(PRBool *aIsCopyItem); \
  NS_IMETHOD SetIsCopyItem(PRBool aIsCopyItem); \
  NS_IMETHOD GetCopyNode(nsIDOMNode * *aCopyNode); \
  NS_IMETHOD CopyNodeEquals(nsIDOMNode *aNode, PRBool *_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIXFORMSITEMELEMENT(_to) \
  NS_IMETHOD GetLabelText(nsAString & aLabelText) { return _to GetLabelText(aLabelText); } \
  NS_IMETHOD GetValue(nsAString & aValue) { return _to GetValue(aValue); } \
  NS_IMETHOD SetActive(PRBool aActive) { return _to SetActive(aActive); } \
  NS_IMETHOD LabelRefreshed(void) { return _to LabelRefreshed(); } \
  NS_IMETHOD GetIsCopyItem(PRBool *aIsCopyItem) { return _to GetIsCopyItem(aIsCopyItem); } \
  NS_IMETHOD SetIsCopyItem(PRBool aIsCopyItem) { return _to SetIsCopyItem(aIsCopyItem); } \
  NS_IMETHOD GetCopyNode(nsIDOMNode * *aCopyNode) { return _to GetCopyNode(aCopyNode); } \
  NS_IMETHOD CopyNodeEquals(nsIDOMNode *aNode, PRBool *_retval) { return _to CopyNodeEquals(aNode, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIXFORMSITEMELEMENT(_to) \
  NS_IMETHOD GetLabelText(nsAString & aLabelText) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLabelText(aLabelText); } \
  NS_IMETHOD GetValue(nsAString & aValue) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetValue(aValue); } \
  NS_IMETHOD SetActive(PRBool aActive) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetActive(aActive); } \
  NS_IMETHOD LabelRefreshed(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->LabelRefreshed(); } \
  NS_IMETHOD GetIsCopyItem(PRBool *aIsCopyItem) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsCopyItem(aIsCopyItem); } \
  NS_IMETHOD SetIsCopyItem(PRBool aIsCopyItem) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetIsCopyItem(aIsCopyItem); } \
  NS_IMETHOD GetCopyNode(nsIDOMNode * *aCopyNode) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCopyNode(aCopyNode); } \
  NS_IMETHOD CopyNodeEquals(nsIDOMNode *aNode, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->CopyNodeEquals(aNode, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsXFormsItemElement : public nsIXFormsItemElement
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIXFORMSITEMELEMENT

  nsXFormsItemElement();

private:
  ~nsXFormsItemElement();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsXFormsItemElement, nsIXFormsItemElement)

nsXFormsItemElement::nsXFormsItemElement()
{
  /* member initializers and constructor code */
}

nsXFormsItemElement::~nsXFormsItemElement()
{
  /* destructor code */
}

/* readonly attribute AString labelText; */
NS_IMETHODIMP nsXFormsItemElement::GetLabelText(nsAString & aLabelText)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString value; */
NS_IMETHODIMP nsXFormsItemElement::GetValue(nsAString & aValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setActive (in boolean aActive); */
NS_IMETHODIMP nsXFormsItemElement::SetActive(PRBool aActive)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void labelRefreshed (); */
NS_IMETHODIMP nsXFormsItemElement::LabelRefreshed()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute boolean isCopyItem; */
NS_IMETHODIMP nsXFormsItemElement::GetIsCopyItem(PRBool *aIsCopyItem)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsXFormsItemElement::SetIsCopyItem(PRBool aIsCopyItem)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIDOMNode copyNode; */
NS_IMETHODIMP nsXFormsItemElement::GetCopyNode(nsIDOMNode * *aCopyNode)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean copyNodeEquals (in nsIDOMNode aNode); */
NS_IMETHODIMP nsXFormsItemElement::CopyNodeEquals(nsIDOMNode *aNode, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIXFormsItemElement_h__ */
